Index: /gs2-extensions/echoprint/trunk/src/CASCADE-MAKE.sh
===================================================================
--- /gs2-extensions/echoprint/trunk/src/CASCADE-MAKE.sh	(revision 27246)
+++ /gs2-extensions/echoprint/trunk/src/CASCADE-MAKE.sh	(revision 27246)
@@ -0,0 +1,18 @@
+#!/bin/bash
+
+source devel.bash
+
+for d in packages ; do
+    echo "Running $d/CASCADE-MAKE.sh"
+
+    (cd $d ; ./CASCADE-MAKE.sh $*)
+
+    if [ $? != 0 ] ; then
+        echo "Error encountered running $d/CASCADE-MAKE.sh"
+        exit 1
+    fi
+done
+
+if [ $makedist = "1"  ] ; then
+  default_toplevel_make_dist $GSDLOS devel.bash
+fi
Index: /gs2-extensions/echoprint/trunk/src/devel.bash
===================================================================
--- /gs2-extensions/echoprint/trunk/src/devel.bash	(revision 27246)
+++ /gs2-extensions/echoprint/trunk/src/devel.bash	(revision 27246)
@@ -0,0 +1,1 @@
+link gs3-devel.sh
Index: /gs2-extensions/echoprint/trunk/src/gs3-devel.sh
===================================================================
--- /gs2-extensions/echoprint/trunk/src/gs3-devel.sh	(revision 27246)
+++ /gs2-extensions/echoprint/trunk/src/gs3-devel.sh	(revision 27246)
@@ -0,0 +1,26 @@
+#!/bin/bash
+
+if [ -d cascade-make ] ; then
+  source cascade-make/lib/cascade-lib.bash GEXT_HUGIN . $*
+fi
+
+if [ -z $GEXT_HUGIN ] ; then
+  source gs3-setup.sh
+fi
+
+if [ -z $GEXTHUGIN_DEVEL ] ; then
+    # Set environment variable so we can tell devel.bash has been sourced
+    export GEXTHUGIN_DEVEL=$GEXT_HUGIN
+    
+    export PATH="$GEXTHUGIN_INSTALLED/bin:$PATH"
+    export CFLAGS="-I$GEXTHUGIN_INSTALLED/include $CFLAGS"
+    export CPPFLAGS="-I$GEXTHUGIN_INSTALLED/include $CPPFLAGS"
+    export CXXFLAGS="-I$GEXTHUGIN_INSTALLED/include $CXXFLAGS"
+    export LDFLAGS="-L$GEXTHUGIN_INSTALLED/lib $LDFLAGS"
+    export PKG_CONFIG_PATH="$GEXTHUGIN_INSTALLED/lib/pkgconfig:$PKG_CONFIG_PATH"
+    
+    echo "+Your environment is now setup to compile with the Hugin Support Library"
+
+else
+    echo "+Your environment is already setup to compile with the Hugin Support Library"
+fi
Index: /gs2-extensions/echoprint/trunk/src/gs3-setup.bat
===================================================================
--- /gs2-extensions/echoprint/trunk/src/gs3-setup.bat	(revision 27246)
+++ /gs2-extensions/echoprint/trunk/src/gs3-setup.bat	(revision 27246)
@@ -0,0 +1,64 @@
+@echo off
+pushd "%CD%"
+CD /D "%~dp0"
+
+set extdesc=the Echoprint-codegen Extension
+
+if "%OS%" == "Windows_NT" goto WinNT
+if "%OS%" == "" goto Win95
+if "%GSDLLANG%" == "en" echo Setup failed - your PATH has not been set
+if "%GSDLLANG%" == "es" echo No se pudo realizar la configuraci¢n - no se ha establecido la RUTA.
+if "%GSDLLANG%" == "fr" echo Echc de l'installation - votre variable PATH n'a pas t ajuste
+if "%GSDLLANG%" == "ru" echo áâ ­®¢ª  ­¥ ã€ « áì -  ­¥ ¡ë« ãáâ ­®¢«¥­
+goto End
+
+:WinNT
+set GEXT_ECHOPRINT=%CD%
+set PATH=%GEXT_ECHOPRINT%\bin\script;%PATH%
+set PATH=%GEXT_ECHOPRINT%\bin\windows;%PATH%
+set PATH=%GEXT_ECHOPRINT%\lib;%PATH%
+set GS_CP_SET=yes
+goto Success
+
+:Win95
+if "%1" == "SetEnv" goto Win95Env
+REM We'll invoke a second copy of the command processor to make
+REM sure there's enough environment space
+COMMAND /E:2048 /K %0 SetEnv
+goto End
+
+:Win95Env
+set GEXT_ECHOPRINT=%CD%
+set PATH="%GEXT_ECHOPRINT%\bin\script";"%PATH%"
+set PATH="%GEXT_ECHOPRINT%\bin\windows";"%PATH%"
+set PATH="%GEXT_ECHOPRINT%\lib";"%PATH%"
+set GS_CP_SET=yes
+goto Success
+
+:Success
+
+set fulldir=%~dp0
+
+:: strip off everything up to (and including) ext dir
+set extdir=%fulldir:*ext\=%
+
+:: remove trailing slash
+set extdir=%extdir:\=%
+
+setlocal enabledelayedexpansion
+if "x%GSDLEXTS%" == "x" (
+  set GSDLEXTS=!extdir!
+) else (
+  set GSDLEXTS=!GSDLEXTS!:!extdir!
+)
+endlocal & set GSDLEXTS=%GSDLEXTS%
+
+echo +Your environment is now setup for %extdesc%
+
+:: Back to delayed expansion to avoid problems with environment
+:: variables with brackets in them, such as "Program Files (x86)"
+
+
+:End
+
+popd
Index: /gs2-extensions/echoprint/trunk/src/gs3-setup.sh
===================================================================
--- /gs2-extensions/echoprint/trunk/src/gs3-setup.sh	(revision 27246)
+++ /gs2-extensions/echoprint/trunk/src/gs3-setup.sh	(revision 27246)
@@ -0,0 +1,57 @@
+
+extdesc="the Echoprint-codegen Extension"
+
+full_setup=`pwd`/${BASH_SOURCE}
+fulldir=${full_setup%/*}
+fulldir=${fulldir%/.}
+
+if test -z $GSDLOS ; then
+  GSDLOS=`uname -s | tr '[A-Z]' '[a-z]'`
+  # check for running bash under Cygwin
+  if test "`echo $GSDLOS | sed 's/cygwin//'`" != "$GSDLOS" ;
+  then
+    GSDLOS=windows
+  fi
+  # check for running bash under MinGW/MSys
+  if test "`echo $GSDLOS | sed 's/mingw//'`" != "$GSDLOS" ;
+  then
+    GSDLOS=windows
+  fi
+  echo "GSDLOS was not set.  Setting it to '$GSDLOS'"
+  export GSDLOS
+fi
+	
+
+if [ "x$GEXT_ECHOPRINT" = "x" ] ; then
+  export GEXT_ECHOPRINT=`pwd`
+  export GEXTECHOPRINT_INSTALLED=$GEXT_ECHOPRINT/$GSDLOS
+
+  if [ -d "$GEXTECHOPRINT_INSTALLED/bin/script" ] ; then
+    export PATH=$GEXTECHOPRINT_INSTALLED/bin/script:$PATH
+  fi
+
+  if [ -d "$GEXTECHOPRINT_INSTALLED/bin" ] ; then
+    export PATH=$GEXTECHOPRINT_INSTALLED/bin:$PATH
+  fi
+
+  if [ -d "$GEXTECHOPRINT_INSTALLED/lib" ] ; then
+    if [ "$GSDLOS" = "linux" ] ; then
+      export LD_LIBRARY_PATH=$GEXTECHOPRINT_INSTALLED/lib:$GEXTECHOPRINT_INSTALLED/lib64:$LD_LIBRARY_PATH
+    elif [ "$GSDLOS" = "darwin" ] ; then
+      export DYLD_LIBRARY_PATH=$GEXTECHOPRINT_INSTALLED/lib:$GEXTECHOPRINT_INSTALLED/lib64:$DYLD_LIBRARY_PATH
+    fi
+  fi
+
+  extdir=${GEXT_ECHOPRINT##*/}
+
+  if [ "x$GSDLEXTS" = "x" ] ; then
+    export GSDLEXTS=$extdir
+  else 
+    export GSDLEXTS=$GSDLEXTS:$extdir
+  fi
+
+
+  echo "+Your environment is now setup for $extdesc"
+else
+  echo "+Your environment is already setup for $extdesc"
+fi
Index: /gs2-extensions/echoprint/trunk/src/setup.bash
===================================================================
--- /gs2-extensions/echoprint/trunk/src/setup.bash	(revision 27246)
+++ /gs2-extensions/echoprint/trunk/src/setup.bash	(revision 27246)
@@ -0,0 +1,1 @@
+link gs3-setup.sh