Index: gs2-extensions/afrepo/trunk/src/devel.bash
===================================================================
--- gs2-extensions/afrepo/trunk/src/devel.bash	(revision 27255)
+++ gs2-extensions/afrepo/trunk/src/devel.bash	(revision 27255)
@@ -0,0 +1,1 @@
+link gs3-devel.sh
Index: gs2-extensions/afrepo/trunk/src/gs3-devel.sh
===================================================================
--- gs2-extensions/afrepo/trunk/src/gs3-devel.sh	(revision 27255)
+++ gs2-extensions/afrepo/trunk/src/gs3-devel.sh	(revision 27255)
@@ -0,0 +1,26 @@
+#!/bin/bash
+
+if [ -d cascade-make ] ; then
+  source cascade-make/lib/cascade-lib.bash GEXT_AFREPO . $*
+fi
+
+if [ -z $GEXT_AFREPO ] ; then
+  source gs3-setup.sh
+fi
+
+if [ -z $GEXTAFREPO_DEVEL ] ; then
+    # Set environment variable so we can tell devel.bash has been sourced
+    export GEXT_AFREPO_DEVEL=$GEXT_AFREPO
+    
+    export PATH="$GEXT_AFREPO_INSTALLED/bin:$PATH"
+    export CFLAGS="-I$GEXT_AFREPO_INSTALLED/include $CFLAGS"
+    export CPPFLAGS="-I$GEXT_AFREPO_INSTALLED/include $CPPFLAGS"
+    export CXXFLAGS="-I$GEXT_AFREPO_INSTALLED/include $CXXFLAGS"
+    export LDFLAGS="-L$GEXT_AFREPO_INSTALLED/lib $LDFLAGS"
+    export PKG_CONFIG_PATH="$GEXT_AFREPO_INSTALLED/lib/pkgconfig:$PKG_CONFIG_PATH"
+    
+    echo "+Your environment is now setup to compile afrepo"
+
+else
+    echo "+Your environment is already setup to compile afrepo"
+fi
Index: gs2-extensions/afrepo/trunk/src/gs3-setup.bat
===================================================================
--- gs2-extensions/afrepo/trunk/src/gs3-setup.bat	(revision 27255)
+++ gs2-extensions/afrepo/trunk/src/gs3-setup.bat	(revision 27255)
@@ -0,0 +1,64 @@
+@echo off
+pushd "%CD%"
+CD /D "%~dp0"
+
+set extdesc=the afrepo (audio fingerprinting) Extension
+
+if "%OS%" == "Windows_NT" goto WinNT
+if "%OS%" == "" goto Win95
+if "%GSDLLANG%" == "en" echo Setup failed - your PATH has not been set
+if "%GSDLLANG%" == "es" echo No se pudo realizar la configuraci¢n - no se ha establecido la RUTA.
+if "%GSDLLANG%" == "fr" echo Echc de l'installation - votre variable PATH n'a pas t ajuste
+if "%GSDLLANG%" == "ru" echo áâ ­®¢ª  ­¥ ã€ « áì -  ­¥ ¡ë« ãáâ ­®¢«¥­
+goto End
+
+:WinNT
+set GEXT_AFREPO=%CD%
+set PATH=%GEXT_AFREPO%\bin\script;%PATH%
+set PATH=%GEXT_AFREPO%\bin\windows;%PATH%
+set PATH=%GEXT_AFREPO%\lib;%PATH%
+set GS_CP_SET=yes
+goto Success
+
+:Win95
+if "%1" == "SetEnv" goto Win95Env
+REM We'll invoke a second copy of the command processor to make
+REM sure there's enough environment space
+COMMAND /E:2048 /K %0 SetEnv
+goto End
+
+:Win95Env
+set GEXT_AFREPO=%CD%
+set PATH="%GEXT_AFREPO%\bin\script";"%PATH%"
+set PATH="%GEXT_AFREPO%\bin\windows";"%PATH%"
+set PATH="%GEXT_AFREPO%\lib";"%PATH%"
+set GS_CP_SET=yes
+goto Success
+
+:Success
+
+set fulldir=%~dp0
+
+:: strip off everything up to (and including) ext dir
+set extdir=%fulldir:*ext\=%
+
+:: remove trailing slash
+set extdir=%extdir:\=%
+
+setlocal enabledelayedexpansion
+if "x%GSDLEXTS%" == "x" (
+  set GSDLEXTS=!extdir!
+) else (
+  set GSDLEXTS=!GSDLEXTS!:!extdir!
+)
+endlocal & set GSDLEXTS=%GSDLEXTS%
+
+echo +Your environment is now setup for %extdesc%
+
+:: Back to delayed expansion to avoid problems with environment
+:: variables with brackets in them, such as "Program Files (x86)"
+
+
+:End
+
+popd
Index: gs2-extensions/afrepo/trunk/src/gs3-setup.sh
===================================================================
--- gs2-extensions/afrepo/trunk/src/gs3-setup.sh	(revision 27255)
+++ gs2-extensions/afrepo/trunk/src/gs3-setup.sh	(revision 27255)
@@ -0,0 +1,57 @@
+
+extdesc="the afrepo (audio-fingerprinting) Extension"
+
+full_setup=`pwd`/${BASH_SOURCE}
+fulldir=${full_setup%/*}
+fulldir=${fulldir%/.}
+
+if test -z $GSDLOS ; then
+  GSDLOS=`uname -s | tr '[A-Z]' '[a-z]'`
+  # check for running bash under Cygwin
+  if test "`echo $GSDLOS | sed 's/cygwin//'`" != "$GSDLOS" ;
+  then
+    GSDLOS=windows
+  fi
+  # check for running bash under MinGW/MSys
+  if test "`echo $GSDLOS | sed 's/mingw//'`" != "$GSDLOS" ;
+  then
+    GSDLOS=windows
+  fi
+  echo "GSDLOS was not set.  Setting it to '$GSDLOS'"
+  export GSDLOS
+fi
+	
+
+if [ "x$GEXT_AFREPO" = "x" ] ; then
+  export GEXT_AFREPO=`pwd`
+  export GEXT_AFREPO_INSTALLED=$GEXT_AFREPO/$GSDLOS
+
+  if [ -d "$GEXT_AFREPO_INSTALLED/bin/script" ] ; then
+    export PATH=$GEXT_AFREPO_INSTALLED/bin/script:$PATH
+  fi
+
+  if [ -d "$GEXT_AFREPO_INSTALLED/bin" ] ; then
+    export PATH=$GEXT_AFREPO_INSTALLED/bin:$PATH
+  fi
+
+  if [ -d "$GEXT_AFREPO_INSTALLED/lib" ] ; then
+    if [ "$GSDLOS" = "linux" ] ; then
+      export LD_LIBRARY_PATH=$GEXT_AFREPO_INSTALLED/lib:$GEXT_AFREPO_INSTALLED/lib64:$LD_LIBRARY_PATH
+    elif [ "$GSDLOS" = "darwin" ] ; then
+      export DYLD_LIBRARY_PATH=$GEXT_AFREPO_INSTALLED/lib:$GEXT_AFREPO_INSTALLED/lib64:$DYLD_LIBRARY_PATH
+    fi
+  fi
+
+  extdir=${GEXT_AFREPO##*/}
+
+  if [ "x$GSDLEXTS" = "x" ] ; then
+    export GSDLEXTS=$extdir
+  else 
+    export GSDLEXTS=$GSDLEXTS:$extdir
+  fi
+
+
+  echo "+Your environment is now setup for $extdesc"
+else
+  echo "+Your environment is already setup for $extdesc"
+fi
Index: gs2-extensions/afrepo/trunk/src/packages/CASCADE-MAKE.sh
===================================================================
--- gs2-extensions/afrepo/trunk/src/packages/CASCADE-MAKE.sh	(revision 27255)
+++ gs2-extensions/afrepo/trunk/src/packages/CASCADE-MAKE.sh	(revision 27255)
@@ -0,0 +1,17 @@
+#!/bin/bash
+
+source ../cascade-make/lib/cascade-lib.bash GEXT_AFREPO .. $*
+
+CMAKE_LIBRARY_PATH=$GEXT_AFREPO_INSTALLED
+LD_LIBRARY_PATH=$GEXT_AFREPO_INSTALLED
+
+for d in GIT ; do
+    echo "    Running CASCADE-MAKE/$d.sh"
+
+    ./CASCADE-MAKE/$d.sh $*
+
+    if [ $? != 0 ] ; then
+	echo "Error encountered running CASCADE-MAKE/$d.sh"
+	exit 1
+    fi
+done
Index: gs2-extensions/afrepo/trunk/src/packages/CASCADE-MAKE/GIT.sh
===================================================================
--- gs2-extensions/afrepo/trunk/src/packages/CASCADE-MAKE/GIT.sh	(revision 27255)
+++ gs2-extensions/afrepo/trunk/src/packages/CASCADE-MAKE/GIT.sh	(revision 27255)
@@ -0,0 +1,21 @@
+#!/bin/bash
+
+package=git
+version=-1.8.2.1
+
+progname=$0
+
+source ../cascade-make/lib/cascade-lib.bash GEXT_AFREPO ../.. $*
+
+prefix=$GEXT_AFREPO_INSTALLED
+
+opt_run_untar $force_untar $auto_untar $package $version
+opt_run_configure $force_config $auto_config $package $version $prefix
+
+opt_run_make $compile $package $version
+opt_run_make $install $package $version "install"
+opt_run_make $clean $package $version "clean"
+opt_run_make $distclean $package $version "distclean"
+
+opt_run_tarclean $tarclean $package $version
+
Index: gs2-extensions/afrepo/trunk/src/setup.bash
===================================================================
--- gs2-extensions/afrepo/trunk/src/setup.bash	(revision 27255)
+++ gs2-extensions/afrepo/trunk/src/setup.bash	(revision 27255)
@@ -0,0 +1,1 @@
+link gs3-setup.sh