Index: gs2-extensions/echoprint/trunk/src/gs3-devel.sh
===================================================================
--- gs2-extensions/echoprint/trunk/src/gs3-devel.sh	(revision 27249)
+++ gs2-extensions/echoprint/trunk/src/gs3-devel.sh	(revision 27267)
@@ -2,25 +2,25 @@
 
 if [ -d cascade-make ] ; then
-  source cascade-make/lib/cascade-lib.bash GEXT_HUGIN . $*
+  source cascade-make/lib/cascade-lib.bash GEXT_ECHOPRINT . $*
 fi
 
-if [ -z $GEXT_HUGIN ] ; then
+if [ -z $GEXT_ECHOPRINT ] ; then
   source gs3-setup.sh
 fi
 
-if [ -z $GEXTHUGIN_DEVEL ] ; then
+if [ -z $GEXTECHOPRINT_DEVEL ] ; then
     # Set environment variable so we can tell devel.bash has been sourced
-    export GEXTHUGIN_DEVEL=$GEXT_HUGIN
+    export GEXTECHOPRINT_DEVEL=$GEXT_ECHOPRINT
     
-    export PATH="$GEXTHUGIN_INSTALLED/bin:$PATH"
-    export CFLAGS="-I$GEXTHUGIN_INSTALLED/include $CFLAGS"
-    export CPPFLAGS="-I$GEXTHUGIN_INSTALLED/include $CPPFLAGS"
-    export CXXFLAGS="-I$GEXTHUGIN_INSTALLED/include $CXXFLAGS"
-    export LDFLAGS="-L$GEXTHUGIN_INSTALLED/lib $LDFLAGS"
-    export PKG_CONFIG_PATH="$GEXTHUGIN_INSTALLED/lib/pkgconfig:$PKG_CONFIG_PATH"
+    export PATH="$GEXTECHOPRINT_INSTALLED/bin:$PATH"
+    export CFLAGS="-I$GEXTECHOPRINT_INSTALLED/include $CFLAGS"
+    export CPPFLAGS="-I$GEXTECHOPRINT_INSTALLED/include $CPPFLAGS"
+    export CXXFLAGS="-I$GEXTECHOPRINT_INSTALLED/include $CXXFLAGS"
+    export LDFLAGS="-L$GEXTECHOPRINT_INSTALLED/lib $LDFLAGS"
+    export PKG_CONFIG_PATH="$GEXTECHOPRINT_INSTALLED/lib/pkgconfig:$PKG_CONFIG_PATH"
     
-    echo "+Your environment is now setup to compile with the Hugin Support Library"
+    echo "+Your environment is now setup to compile with the Echoprint Support Library"
 
 else
-    echo "+Your environment is already setup to compile with the Hugin Support Library"
+    echo "+Your environment is already setup to compile with the Echoprint Support Library"
 fi
Index: gs2-extensions/echoprint/trunk/src/packages/CASCADE-MAKE.sh
===================================================================
--- gs2-extensions/echoprint/trunk/src/packages/CASCADE-MAKE.sh	(revision 27249)
+++ gs2-extensions/echoprint/trunk/src/packages/CASCADE-MAKE.sh	(revision 27267)
@@ -10,5 +10,5 @@
 echo $LD_LIBRARY_PATH;
 
-for d in CMAKE ZLIB BOOST ; do
+for d in CMAKE ZLIB BZIP2 BOOST TAGLIB ; do
     echo "    Running CASCADE-MAKE/$d.sh"
 
Index: gs2-extensions/echoprint/trunk/src/packages/CASCADE-MAKE/BOOST.sh
===================================================================
--- gs2-extensions/echoprint/trunk/src/packages/CASCADE-MAKE/BOOST.sh	(revision 27249)
+++ gs2-extensions/echoprint/trunk/src/packages/CASCADE-MAKE/BOOST.sh	(revision 27267)
@@ -6,7 +6,7 @@
 progname=$0
 
-source ../cascade-make/lib/cascade-lib.bash GEXT_HUGIN ../.. $*
+source ../cascade-make/lib/cascade-lib.bash GEXT_ECHOPRINT ../.. $*
 
-prefix=$GEXTHUGIN_INSTALLED
+prefix=$GEXTECHOPRINT_INSTALLED
 
 opt_run_untar $force_untar $auto_untar $package $version
Index: gs2-extensions/echoprint/trunk/src/packages/CASCADE-MAKE/CMAKE.sh
===================================================================
--- gs2-extensions/echoprint/trunk/src/packages/CASCADE-MAKE/CMAKE.sh	(revision 27249)
+++ gs2-extensions/echoprint/trunk/src/packages/CASCADE-MAKE/CMAKE.sh	(revision 27267)
@@ -6,7 +6,7 @@
 progname=$0
 
-source ../cascade-make/lib/cascade-lib.bash GEXT_HUGIN ../.. $*
+source ../cascade-make/lib/cascade-lib.bash GEXT_ECHOPRINT ../.. $*
 
-prefix=$GEXTHUGIN_INSTALLED
+prefix=$GEXTECHOPRINT_INSTALLED
 
 opt_run_untar $force_untar $auto_untar $package $version
Index: gs2-extensions/echoprint/trunk/src/packages/CASCADE-MAKE/ZLIB.sh
===================================================================
--- gs2-extensions/echoprint/trunk/src/packages/CASCADE-MAKE/ZLIB.sh	(revision 27249)
+++ gs2-extensions/echoprint/trunk/src/packages/CASCADE-MAKE/ZLIB.sh	(revision 27267)
@@ -6,7 +6,7 @@
 progname=$0
 
-source ../cascade-make/lib/cascade-lib.bash GEXT_HUGIN ../.. $*
+source ../cascade-make/lib/cascade-lib.bash GEXT_ECHOPRINT ../.. $*
 
-prefix=$GEXTHUGIN_INSTALLED
+prefix=$GEXTECHOPRINT_INSTALLED
 
 opt_run_untar $force_untar $auto_untar $package $version