Index: gs2-extensions/afrepo/trunk/src/packages/CASCADE-MAKE.sh
===================================================================
--- gs2-extensions/afrepo/trunk/src/packages/CASCADE-MAKE.sh	(revision 27266)
+++ gs2-extensions/afrepo/trunk/src/packages/CASCADE-MAKE.sh	(revision 27269)
@@ -6,5 +6,5 @@
 LD_LIBRARY_PATH=$GEXT_AFREPO_INSTALLED
 
-for d in GIT ; do
+for d in GIT PCRE RAPTOR2 RASQAL NCURSES 4STORE ; do
     echo "    Running CASCADE-MAKE/$d.sh"
 
Index: gs2-extensions/afrepo/trunk/src/packages/CASCADE-MAKE/4STORE.sh
===================================================================
--- gs2-extensions/afrepo/trunk/src/packages/CASCADE-MAKE/4STORE.sh	(revision 27269)
+++ gs2-extensions/afrepo/trunk/src/packages/CASCADE-MAKE/4STORE.sh	(revision 27269)
@@ -0,0 +1,23 @@
+#!/bin/bash
+
+package=4store
+version=-v1.1.5
+
+progname=$0
+
+source ../cascade-make/lib/cascade-lib.bash GEXT_AFREPO ../.. $*
+
+prefix=$GEXT_AFREPO_INSTALLED
+
+opt_run_untar $force_untar $auto_untar $package $version
+opt_run_configure $force_config $auto_config $package $version $prefix \
+  RAPTOR_CFLAGS=-I$GEXT_AFREPO_INSTALLED/include/raptor2 RAPTOR_LIBS="$GEXT_AFREPO_INSTALLED/lib/libraptor2.so" \
+  RASQAL_CFLAGS=-I$GEXT_AFREPO_INSTALLED/include/rasqal RASQAL_LIBS="$GEXT_AFREPO_INSTALLED/lib/librasqal.so" 
+
+opt_run_make $compile $package $version
+opt_run_make $install $package $version "install"
+opt_run_make $clean $package $version "clean"
+opt_run_make $distclean $package $version "distclean"
+
+opt_run_tarclean $tarclean $package $version
+
Index: gs2-extensions/afrepo/trunk/src/packages/CASCADE-MAKE/NCURSES.sh
===================================================================
--- gs2-extensions/afrepo/trunk/src/packages/CASCADE-MAKE/NCURSES.sh	(revision 27269)
+++ gs2-extensions/afrepo/trunk/src/packages/CASCADE-MAKE/NCURSES.sh	(revision 27269)
@@ -0,0 +1,21 @@
+#!/bin/bash
+
+package=ncurses
+version=-5.9
+
+progname=$0
+
+source ../cascade-make/lib/cascade-lib.bash GEXT_AFREPO ../.. $*
+
+prefix=$GEXT_AFREPO_INSTALLED
+
+opt_run_untar $force_untar $auto_untar $package $version
+opt_run_configure $force_config $auto_config $package $version $prefix
+
+opt_run_make $compile $package $version
+opt_run_make $install $package $version "install"
+opt_run_make $clean $package $version "clean"
+opt_run_make $distclean $package $version "distclean"
+
+opt_run_tarclean $tarclean $package $version
+
Index: gs2-extensions/afrepo/trunk/src/packages/CASCADE-MAKE/PCRE.sh
===================================================================
--- gs2-extensions/afrepo/trunk/src/packages/CASCADE-MAKE/PCRE.sh	(revision 27269)
+++ gs2-extensions/afrepo/trunk/src/packages/CASCADE-MAKE/PCRE.sh	(revision 27269)
@@ -0,0 +1,21 @@
+#!/bin/bash
+
+package=pcre
+version=-8.32
+
+progname=$0
+
+source ../cascade-make/lib/cascade-lib.bash GEXT_AFREPO ../.. $*
+
+prefix=$GEXT_AFREPO_INSTALLED
+
+opt_run_untar $force_untar $auto_untar $package $version
+opt_run_configure $force_config $auto_config $package $version $prefix
+
+opt_run_make $compile $package $version
+opt_run_make $install $package $version "install"
+opt_run_make $clean $package $version "clean"
+opt_run_make $distclean $package $version "distclean"
+
+opt_run_tarclean $tarclean $package $version
+
Index: gs2-extensions/afrepo/trunk/src/packages/CASCADE-MAKE/RAPTOR2.sh
===================================================================
--- gs2-extensions/afrepo/trunk/src/packages/CASCADE-MAKE/RAPTOR2.sh	(revision 27269)
+++ gs2-extensions/afrepo/trunk/src/packages/CASCADE-MAKE/RAPTOR2.sh	(revision 27269)
@@ -0,0 +1,21 @@
+#!/bin/bash
+
+package=raptor2
+version=-2.0.9
+
+progname=$0
+
+source ../cascade-make/lib/cascade-lib.bash GEXT_AFREPO ../.. $*
+
+prefix=$GEXT_AFREPO_INSTALLED
+
+opt_run_untar $force_untar $auto_untar $package $version
+opt_run_configure $force_config $auto_config $package $version $prefix
+
+opt_run_make $compile $package $version
+opt_run_make $install $package $version "install"
+opt_run_make $clean $package $version "clean"
+opt_run_make $distclean $package $version "distclean"
+
+opt_run_tarclean $tarclean $package $version
+
Index: gs2-extensions/afrepo/trunk/src/packages/CASCADE-MAKE/RASQAL.sh
===================================================================
--- gs2-extensions/afrepo/trunk/src/packages/CASCADE-MAKE/RASQAL.sh	(revision 27269)
+++ gs2-extensions/afrepo/trunk/src/packages/CASCADE-MAKE/RASQAL.sh	(revision 27269)
@@ -0,0 +1,21 @@
+#!/bin/bash
+
+package=rasqal
+version=-0.9.30
+
+progname=$0
+
+source ../cascade-make/lib/cascade-lib.bash GEXT_AFREPO ../.. $*
+
+prefix=$GEXT_AFREPO_INSTALLED
+
+opt_run_untar $force_untar $auto_untar $package $version
+opt_run_configure $force_config $auto_config $package $version $prefix
+
+opt_run_make $compile $package $version
+opt_run_make $install $package $version "install"
+opt_run_make $clean $package $version "clean"
+opt_run_make $distclean $package $version "distclean"
+
+opt_run_tarclean $tarclean $package $version
+