Index: /main/trunk/greenstone2/macros/document.dm
===================================================================
--- /main/trunk/greenstone2/macros/document.dm	(revision 27293)
+++ /main/trunk/greenstone2/macros/document.dm	(revision 27294)
@@ -124,4 +124,5 @@
 #######################################################################
 
+# The div that loads the user comments that were already submitted
 # associated javascript function loadUserComments is in style.dm's _globalscripts_ macro
 _usercomments_ {
@@ -131,7 +132,19 @@
 }
 
-
 # Display the add-user-comment form on actual document pages and not when browsing/searching
 # This means the form should only be displayed on pages where the _cgiargd_ (the docid) is set
+
+# If the user's logged in, show the comment form, else show the link to the login page
+_addusercomment_ {
+_If_(_cgiargd_,
+_If_(_cgiargun_,_usercommentform_,_loginlink_)
+)
+}
+
+_doc-url_ {_gwcgi_?e=_compressedoptions_&amp;a=_cgiarga_&amp;c=_cgiargc_&amp;cl=_cgiargcl_&amp;d=_cgiargd_}
+
+_loginlink_ {
+<div id="usercommentlink"><a href="_doc-url_&amp;uan=1">_textaddusercomment_</a></div>
+}
 
 # For getting the submitbutton to make Ajax calls, see
@@ -139,10 +152,8 @@
 # http://stackoverflow.com/questions/8869341/ajax-form-submit-with-submit-button
 
-_addusercomment_ {
-
-_If_(_cgiargd_,
-
+_usercommentform_ {
 <form name="AddUserCommentForm">
-<p>_textcommentusername_ <input type="text" name="username"></p>
+<!--<p>_textcommentusername_ <input type="text" name="username"></p>-->
+<input type=hidden name="username" value="_cgiargun_">
 <p>
 _textaddusercomment_
@@ -154,5 +165,5 @@
 <label id="usercommentfeedback"></label>
 </form>
-)
+
 
 <script type="text/javascript">  
@@ -656,7 +667,4 @@
 </div> <!-- document:footer -->
 
-<div class="navarrowsbottom">
-_navarrowsbottom_
-</div>
 
 <center>
@@ -669,4 +677,9 @@
 </td></tr></table>
 </center>
+
+<div class="navarrowsbottom">
+_navarrowsbottom_
+</div>
+
 
 _endspacer__htmlfooter_
Index: /main/trunk/greenstone2/macros/english.dm
===================================================================
--- /main/trunk/greenstone2/macros/english.dm	(revision 27293)
+++ /main/trunk/greenstone2/macros/english.dm	(revision 27294)
@@ -336,9 +336,10 @@
 }
 
-_textcommentusername_ {User name:}
-_textaddusercomment_ {Comment:}
-_textaddcomment_ {add comment}
+_textcommentusername_ {User name}
+_textaddusercomment_ {Add Comment}
+_textaddcomment_ {submit comment}
 _textcommentsubmitted_ {Comment Submitted}
-_text-is-empty_ {Can't add empty values}
+_text-is-empty_ {Comment was empty.}
+_text-usercomments-section_ {Comments}
 
 _textgoto_ {go to page}
Index: /main/trunk/greenstone2/macros/style.dm
===================================================================
--- /main/trunk/greenstone2/macros/style.dm	(revision 27293)
+++ /main/trunk/greenstone2/macros/style.dm	(revision 27294)
@@ -330,6 +330,15 @@
 	// (we do this here for all values together to hopefully avoid reloading the page for each comment)
 
+	if(metapos > 0) \{ 
+		var heading=document.createElement("div");
+		var attr=document.createAttribute("class");
+		attr.nodeValue="usercommentheading";
+		heading.setAttributeNode(attr);
+		var txt=document.createTextNode("_text-usercomments-section_");
+		heading.appendChild(txt);
+		usercommentdiv.appendChild(heading);
+	\}
+
 	for(var i = 0; i < metapos; i++) \{
-
 		var comment_record = comments_arraymap[i];
 
Index: /main/trunk/greenstone2/web/style/style.css
===================================================================
--- /main/trunk/greenstone2/web/style/style.css	(revision 27293)
+++ /main/trunk/greenstone2/web/style/style.css	(revision 27294)
@@ -334,2 +334,25 @@
     text-transform:capitalize;
 }
+
+#usercomments {
+    margin: 10px 0;
+}
+
+.usercommentheading {
+    font-weight: bold;
+    color: #006666;
+    border-top: solid 1px black;
+}
+
+.usercomment {
+    margin: 10px 0;
+}
+
+#usercommentlink {
+    margin: 10px 0 20px 0;
+}
+
+#usercommentlink a {
+ text-decoration: none;
+ font-weight: bold;
+}